// Fig. 7.4: Test.java
// Casting superclass references to subclass references
import java.text.DecimalFormat;
import java.io.*;

public class Test  {

   public static void main(String[] args) throws java.io.IOException
   {Point pointRef, p=new Point(30,50);
    Circle circleRef, c=new Circle(1.5,4,10);
    Cylinder cylRef, cyl=new Cylinder(5,5,10,5);

      DecimalFormat precision2 = new DecimalFormat( "#.00" );

      System.out.println( "Point p: " + p);
      System.out.println( "Circle c: " + c +
                                  " Area: "+ precision2.format(c.area()));
      System.out.println("Cylinder cyl: "+cyl+
            " Surface Area: "+precision2.format(cyl.area())
                                +" Volume: "+precision2.format(cyl.volume()));

      // Attempt to treat a Circle as a Point
      pointRef = c;   // assign Circle to pointRef
      System.out.println( "Circle c (via pointRef): " +pointRef +
                                         " Area: "+ precision2.format(c.area()));

      // Attempt to treat a Cylinder as a Point
      pointRef = cyl;   // assign Cylinder to pointRef
      System.out.println( "Cylinder cyl (via pointRef): " +pointRef+
                          " Surface Area: "+ precision2.format(cyl.area()) +
                                    " Volume: "+precision2.format(cyl.volume()));

      // Treat a Circle as a Circle (with some casting)
      pointRef=c;
      circleRef = (Circle) pointRef;  // cast super to sub
      System.out.println( "Circle c (via circleRef): " +circleRef);
      System.out.println( " Area of c (via circleRef): " +
                                     precision2.format(circleRef.area()));

      // Attempt to refer to Point object
      // with Circle reference
      try {
          circleRef = (Circle) p;    // line 39 in Test.java
      }
      catch (Exception e) {
            System.out.println("Point via Circle Reference Crashed");
      }

      System.out.println("END");
   }
}
